const worker = new Worker("worker.js");

let i = 0;

let cb = {};

worker.addEventListener("message", ev => {
  if (ev.data.i in cb) {
    cb[ev.data.i](ev.data.res);
  }
})

export default (arr: ArrayBuffer) => new Promise((res, rej) => {
  i++;
  const _i = i;
  worker.postMessage({ i: _i, arr });
  cb[_i] = res;
});